Hid hi;
HidMsg msg;

// which keyboard
0 => int device;
// get from command line
if( me.args() ) me.arg(0) => Std.atoi => device;

// open keyboard (get device number from command line)
if( !hi.openKeyboard( device ) ) me.exit();
<<< "keyboard '" + hi.name() + "' ready", "" >>>;

//1234... row
49  => int ascii_1;
50  => int ascii_2;
51  => int ascii_3;
52  => int ascii_4;
53  => int ascii_5;
54  => int ascii_6;
55  => int ascii_7;
56  => int ascii_8;
57  => int ascii_9;
48  => int ascii_0;
45  => int ascii_hyphen; // hyphen
61  => int ascii_equals; // equals

//qwer... row
81  => int ascii_q;
87  => int ascii_w;
69  => int ascii_e;
82  => int ascii_r;
84  => int ascii_t;
89  => int ascii_y;
85  => int ascii_u;
73  => int ascii_i;
79  => int ascii_o;
80  => int ascii_p;
91  => int ascii_leftBracket; // leftBracket
93  => int ascii_rightBracket; // rightBracket
92  => int ascii_backSlash; // backSlash

//asdf... row	[4, 22, 7, 9, 10, 11, 13, 14, 15, 51, 52]
65  => int ascii_a;
83  => int ascii_s;
68  => int ascii_d;
70  => int ascii_f;
71  => int ascii_g;
72  => int ascii_h;
74  => int ascii_j;
75  => int ascii_k;
76  => int ascii_l;
59  => int ascii_semicolon; // semicolon
39  => int ascii_singleQuote; // singleQuote

//zxcv... row	[29, 27, 6, 25, 5, 17, 16, 54, 55, 56]
90  => int ascii_z;
88  => int ascii_x;
67  => int ascii_c;
86  => int ascii_v;
66  => int ascii_b;
78  => int ascii_n;
77  => int ascii_m;
44  => int ascii_comma; // comma
46  => int ascii_period; // period
47  => int ascii_forwardSlash; // forwardSlash

function void playIt( string str )
{    
    <<< "You typed", str >>>;
}

// infinite event loop
while( true )
{
    // wait on event
    hi => now;
    
    // get one or more messages
    while( hi.recv( msg ) )
    {
        // check for action type
        if( msg.isButtonDown() )
        {
            // Row 1 2 3 4 5
            if ( msg.ascii == ascii_1 ) // remove the initial else
            {
                playIt( "1" );
            }
            else if ( msg.ascii == ascii_2 )
            {
                playIt( "2" );
            }
            else if ( msg.ascii == ascii_3 )
            {
                playIt( "3" );
            }
            else if ( msg.ascii == ascii_4 )
            {
                playIt( "4" );
            }
            else if ( msg.ascii == ascii_5 )
            {
                playIt( "5" );
            }
            else if ( msg.ascii == ascii_6 )
            {
                playIt( "6" );
            }
            else if ( msg.ascii == ascii_7 )
            {
                playIt( "7" );
            }
            else if ( msg.ascii == ascii_8 )
            {
                playIt( "8" );
            }
            else if ( msg.ascii == ascii_9 )
            {
                playIt( "9" );
            }
            else if ( msg.ascii == ascii_0 )
            {
                playIt( "10" );
            }
            else if ( msg.ascii == ascii_hyphen  ) // ascii_hyphen
            { 
                playIt( "-" );
            }
            else if ( msg.ascii == ascii_equals ) // ascii_equals
            {
                playIt( "=" );
            }
            // Row q w e r t
            else if ( msg.ascii == ascii_q )
            {
                playIt( "q" );
            }
            else if ( msg.ascii == ascii_w )
            {
                playIt( "w" );
            }
            else if ( msg.ascii == ascii_e )
            {
                playIt( "e" );
            }
            else if ( msg.ascii == ascii_r )
            {
                playIt( "r" );
            }
            else if ( msg.ascii == ascii_t )
            {
                playIt( "t" );
            }
            else if ( msg.ascii == ascii_y )
            {
                playIt( "y" );
            }
            else if ( msg.ascii == ascii_u )
            {
                playIt( "u" );
            }
            else if ( msg.ascii == ascii_i )
            {
                playIt( "i" );
            }
            else if ( msg.ascii == ascii_o )
            {
                playIt( "o" );
            }
            else if ( msg.ascii == ascii_p )
            {
                playIt( "p" );
            }
            else if ( msg.ascii == ascii_leftBracket ) // ascii_leftBracket
            {
                playIt( "[" );
            }
            else if ( msg.ascii == ascii_rightBracket ) // ascii_rightBracket
            {
                playIt( "]" );
            }
            else if ( msg.ascii == ascii_backSlash ) // ascii_backSlash
            {
                playIt( "\\" );
            }
            // Row a s d f g
            else if ( msg.ascii == ascii_a )
            {
                playIt( "a" );
            }
            else if ( msg.ascii == ascii_s )
            {
                playIt( "s" );
            }
            else if ( msg.ascii == ascii_d )
            {
                playIt( "d" );
            }
            else if ( msg.ascii == ascii_f )
            {
                playIt( "g" );
            }
            else if ( msg.ascii == ascii_g )
            {
                playIt( "g" );
            }
            else if ( msg.ascii == ascii_h )
            {
                playIt( "h" );
            }
            else if ( msg.ascii == ascii_j )
            {
                playIt( "j" );
            }
            else if ( msg.ascii == ascii_k )
            {
                playIt( "k" );
            }
            else if ( msg.ascii == ascii_l )
            {
                playIt( "l" );
            }
            else if ( msg.ascii == ascii_semicolon ) // ascii_semicolon
            {
                playIt( ";" );
            }
            else if ( msg.ascii == ascii_singleQuote ) // ascii_singleQuote
            {
                playIt( "'" );
            }
            // Row z x c v b
            else if ( msg.ascii == ascii_z )
            {
                playIt( "z" );
            }
            else if ( msg.ascii == ascii_x )
            {
                playIt( "x" );
            }
            else if ( msg.ascii == ascii_c )
            {
                playIt( "c" );
            }
            else if ( msg.ascii == ascii_v )
            {
                playIt( "v" );
            }
            else if ( msg.ascii == ascii_b )
            {
                playIt( "b" );
            }
            else if ( msg.ascii == ascii_n )
            {
                playIt( "n" );
            }
            else if ( msg.ascii == ascii_m )
            {
                playIt( "m" );
            }
            else if ( msg.ascii == ascii_comma ) // ascii_comma
            {
                playIt( "," );
            }
            else if ( msg.ascii == ascii_period ) // ascii_period
            {
                playIt( "." );
            }
            else if ( msg.ascii == ascii_forwardSlash ) // ascii_forwardSlash
            {
                playIt( "/" );
            }
        }        
        else if( msg.isButtonUp() )
        {
        }
    }
}
